#include <stdio.h>
#include <stdlib.h>

int main()
{
    int duzinaNiza,duzinaPodniza,krajnjiKoeficijent;
    int glavniNiz[200000];

    scanf("%d %d %d", &duzinaNiza, &duzinaPodniza, &krajnjiKoeficijent);
    for(int i=0;i<duzinaNiza;i++){
        scanf("%d", &glavniNiz[i]);
    }

    int nizRezultata[200000]={0};

    for(int i =0; i<duzinaNiza-duzinaPodniza+1;i++){
        int koeficijent = 1;
        int indeksPorastaKoeficijenta;
        //for(int j=i; j<duzinaPodniza+i;j++){

        //}
        for(int j=i;j<duzinaPodniza+i;j++){
            if(j>duzinaPodniza+i-(krajnjiKoeficijent-koeficijent)){
                koeficijent++;
                koeficijent=(koeficijent>krajnjiKoeficijent)?krajnjiKoeficijent:koeficijent;
            }
            //printf("koeficijent:%d", koeficijent);
            nizRezultata[i]+=glavniNiz[j] * koeficijent;
            koeficijent=(nizRezultata[i]<0)?koeficijent+1:koeficijent;
        }
    }

    for(int i=0;i<duzinaNiza-duzinaPodniza+1;i++){
        printf("%d",nizRezultata[i]);
        if(i<duzinaNiza-duzinaPodniza){printf(" ");}
    }
}